/**
 * Toggle class
 * @param {object} node element
 * @param {string} className to toggle
 */
 function toggleClass(node, className) {
    if (node === null) {
        return;
    }

    if (node.className.indexOf(className) > 0) {
        node.className = node.className.replace(' ' + className, '');
    } else {
        node.className += ' ' + className;
    }
}

var wpcf7Elm = document.querySelector( '#idsk-footer-extended-feedback-content .wpcf7' );

if (wpcf7Elm) {
    wpcf7Elm.addEventListener( 'wpcf7mailsent', function( e ) {
        
        var $noOption = document.querySelector('#idsk-footer-extended-help-form');
        var $errorOption = document.querySelector('#idsk-footer-extended-error-form');
        var $infoQuestion = document.querySelector('#idsk-footer-extended-info-question');
        var $heartSymbol = document.querySelector('#idsk-footer-extended-heart');
        var $feedbackQuestion = document.querySelector('#idsk-footer-extended-feedback');
        var $helpAndErrorContainer = document.querySelector('#idsk-footer-extended-feedback-content');

        toggleClass($helpAndErrorContainer, 'idsk-footer-extended-feedback-content');
        $noOption.classList.add('idsk-footer-extended-display-hidden');
        $errorOption.classList.add('idsk-footer-extended-display-hidden');
        $noOption.classList.remove('idsk-footer-extended-open');
        $errorOption.classList.remove('idsk-footer-extended-open');

        toggleClass($infoQuestion, 'idsk-footer-extended-heart');
        toggleClass($heartSymbol, 'idsk-footer-extended-heart-visible');
        toggleClass($feedbackQuestion, 'idsk-footer-extended-display-none');
    }, false );
}