<?php
/**
 * The header.
 *
 * This is the template that displays all of the <head> section and everything up until main.
 *
 * @link https://slovenskoit.sk
 * 
 * @package WordPress
 * @subpackage ID-SK
 * @since ID-SK 1.0
 */
?>

<!DOCTYPE html>
<html <?php language_attributes(); ?> class="govuk-template app-no-canvas-background">
<head>
    <meta charset="<?php bloginfo( 'charset' ); ?>"/>
    <meta name="viewport" content="width=device-width, initial-scale=1, viewport-fit=cover">
    <meta name="theme-color" content="#0b0c0c"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
    <?php wp_head(); ?>
</head>
<body <?php body_class('govuk-template__body'); ?>>
    <?php wp_body_open(); ?>

    <a href="#main-content" class="govuk-skip-link idsk-skip-link--sticky"><?php echo esc_html__( 'Preskočiť na hlavný obsah', 'idsk-template' ); ?></a>
    
    <header class="idsk-header-extended" data-module="idsk-header-extended">
        <div class="idsk-header-extended__container govuk-width-container">
            <?php get_template_part( 'inc/partials/header-extended/nav', 'logo' ); ?>
            <?php get_search_form(); ?>
            <?php get_template_part( 'inc/partials/header-extended/socials' ); ?>
            <button 
                type="button" 
                class="idsk-header-extended__menu-button idsk-js-header-extended-side-menu"
                aria-controls="navigation"
                aria-label="<?php echo esc_attr__( 'Zobraziť alebo skryť navigáciu najvyššej úrovne', 'idsk-template' ); ?>"
                ><?php echo esc_html__( 'Menu', 'idsk-template' ); ?>
                <svg width="40" height="40" viewBox="0 0 40 40" fill="none" xmlns="http://www.w3.org/2000/svg">
                <line x1="5" y1="19.8752" x2="35" y2="19.8752" stroke="#003078" stroke-width="3"/>
                <line x1="5" y1="29.2507" x2="30.5009" y2="29.2507" stroke="#003078" stroke-width="3"/>
                <line x1="5.00177" y1="10.5" x2="30.5027" y2="10.5" stroke="#003078" stroke-width="3" stroke-linejoin="round"/>
                </svg>
            </button>
            <?php get_template_part( 'inc/partials/header-extended/navigation' ); ?>
            
            <div class="idsk-header-extended__mobile">
                <?php get_template_part( 'inc/partials/header-extended/nav', 'logo' ); ?>
                <?php get_search_form(); ?>
                <?php get_template_part( 'inc/partials/header-extended/navigation' ); ?>
                <hr class="idsk-header-extended__hr">
                <?php get_template_part( 'inc/partials/header-extended/socials' ); ?>
                <button class="idsk-header-extended__mobile-close">
                    <span class="govuk-visually-hidden">
                        <?php echo esc_html__( 'Zavrieť menu', 'idsk-template' ); ?>
                    </span>
                </button>
            </div>
        </div>
    </header>
    <div class="idsk-header-extended-ie-fix"></div>
    <div class="idsk-header-extended-notification"></div>
    
    <!-- ///// -->
    <?php get_template_part( 'inc/partials/global', 'info' ); ?>
    <?php get_template_part( 'inc/partials/phase', 'banner' ); ?>
    <?php get_template_part( 'inc/partials/alert', 'panel' ); ?>
    <?php get_template_part( 'inc/partials/breadcrumbs' ); ?>
    <!-- ///// -->

    <main class="govuk-main-wrapper govuk-main-wrapper--auto-spacing govuk-!-padding-top-6 govuk-!-padding-bottom-6 govuk-body" id="main-content" role="main">