<?php
/**
 * The main template file
 * 
 * @link https://slovenskoit.sk
 *
 * @package WordPress
 * @subpackage ID-SK
 * @since ID-SK 1.0
 */

get_header(); ?>

<div class="govuk-width-container">

    <?php
    if ( have_posts() ) {
        
        // Load posts loop.
        while ( have_posts() ) {
            the_post();
            
            echo '<h1 class="govuk-heading-xl govuk-!-margin-bottom-6">' . esc_html( get_the_title() ) . '</h1>';
            
            the_content();

            // If comments are open or there is at least one comment, load up the comment template.
            if ( comments_open() || get_comments_number() ) {
                comments_template();
            }
            echo '<hr class="govuk-section-break govuk-section-break--m govuk-section-break--visible" style="clear: both;">';
        }

        // Custom pagination
        $post_pages = paginate_links(array(
                    'echo'      => false, 
                    'type'      => 'array', 
                    'prev_text' => sprintf(
                        '%s %s',
                        is_rtl() ? esc_html__( '>', 'idsk-template' ) : esc_html__( '<', 'idsk-template' ),
                        esc_html__( 'Staršie články', 'idsk-template' )
                    ),
                    'next_text' => sprintf(
                        '%s %s',
                        esc_html__( 'Novšie články', 'idsk-template' ),
                        is_rtl() ? esc_html__( '<', 'idsk-template' ) : esc_html__( '>', 'idsk-template' )
                    ),
                ));

        if( is_array( $post_pages ) ) {
            $output = '';

            foreach ($post_pages as $post_page) {

                $customPage = str_replace('<a class="', '<a class="govuk-button govuk-button--secondary ', $post_page);
                $customPage = str_replace('<span aria-current="page" class="', '<span aria-current="page" class="govuk-button ', $customPage);

                $output .= $customPage;
            }

            echo wp_kses($output, array('a' => array( 'href' => array(), 'class' => array(), 'title' => array() ), 'span' => array( 'aria-current' => array(), 'class' => array() )));
        }
        
    } ?>

</div>

<?php
get_footer();
