<?php
/**
 * Template Name: In-page navigácia
 * Template Post Type: page, post
 * 
 * Inpage navigation works with WordPress HTML anchors
 */
get_header();
?>
<div class="govuk-width-container">
    <?php

    $back_text = get_post_meta( get_the_ID(), 'idsktk_back_button_text', TRUE );
    $back_link = get_post_meta( get_the_ID(), 'idsktk_back_button_url', TRUE );

    if ( !empty( $back_link ) ) :
        echo '<a href="' . esc_url( $back_link ) . '" class="govuk-back-link" title="'.esc_attr( $back_text ).'">' . esc_html( $back_text ) . '</a>';
    endif;

    if ( have_posts() ) { ?>
        <div class="govuk-grid-row">

            <div class="idsk-in-page-navigation govuk-grid-column-one-quarter" data-module="idsk-in-page-navigation">
                <div class="idsk-in-page-navigation-wrapper">
                    <div class="idsk-in-page-navigation__title"><?php echo esc_html__( 'Obsah', 'idsk-template' ); ?></div>
                    <div class="idsk-in-page-navigation__link-panel">
                        <button class="idsk-in-page-navigation__link-panel-button"><?php echo esc_html__( 'Úvod', 'idsk-template' ); ?></button>
                    </div>
                    
                    <ul class="idsk-in-page-navigation__list">
                        <li class="idsk-in-page-navigation__list-item idsk-in-page-navigation__list-item--active">
                            <a class="idsk-in-page-navigation__link" href="#uvod">
                                <span class="idsk-in-page-navigation__link-number"><?php echo esc_html__( '1.', 'idsk-template' ); ?></span> <span class="idsk-in-page-navigation__link-title"><?php echo esc_html__( 'Úvod', 'idsk-template' ); ?></span>
                            </a>
                        </li>

                        <?php
                        // Load posts loop.
                        while ( have_posts() ) {
                            the_post();

                            $get_content = apply_filters('the_content', get_the_content());
                            $content = new DOMDocument();
                            libxml_use_internal_errors(true);
                            $content->loadHTML( '<?xml encoding="utf-8" ?>' . $get_content );
                            libxml_clear_errors();
                            $xpath_content = new DOMXpath($content);
                            $elems = $xpath_content->query('//h1[@id] | //h2[@id] | //h3[@id] | //h4[@id] | //h5[@id] | //h6[@id] | //p[@id]');

                            $index = 2;
                            foreach($elems as $el) {
                                ?>
                                
                                <li class="idsk-in-page-navigation__list-item "> 
                                    <a class="idsk-in-page-navigation__link" href="<?php echo esc_url( '#'.$el->getAttribute('id') ); ?>">
                                        <span class="idsk-in-page-navigation__link-number"><?php echo esc_html( $index ); ?>.</span> <span class="idsk-in-page-navigation__link-title"><?php echo esc_html( $el->textContent ); ?></span>
                                    </a>
                                </li>

                                <?php
                                $index++;
                            }
                        }
                        ?>
                    </ul>
                </div>
            </div>

            <div class="govuk-grid-column-three-quarters-from-desktop " id="uvod">
                <h1 class="govuk-heading-xl govuk-!-margin-bottom-6"><?php echo esc_html( get_the_title() ) ?></h1>
                <?php
                // Reset pointer to the start.
                rewind_posts();
                // Load posts loop.
                while ( have_posts() ) {
                    the_post();
                    the_content();
                }
                ?>
            </div>
        </div>
    <?php    
    }
    ?>
</div>
<?php
get_footer();
